Package csb :: Package bio :: Package io :: Module wwpdb :: Class AbstractResidueMapper

[frames] | no frames]

# Class AbstractResidueMapper

source code

    object --+
             |
            AbstractResidueMapper

Known Subclasses:
  - CombinedResidueMapper
  - , FastResidueMapper
  - , RobustResidueMapper

Defines the base interface of all residue mappers, used to align PDB ATOM records to the real (SEQRES) sequence of a chain.

Nested Classes
| __metaclass__ Metaclass for defining Abstract Base Classes (ABCs).

Instance Methods

ResidueInfo

create_gap(self, alphabet=<ProteinAlphabet: ILE=I, GLN=Q, ...>) Create and return a new gap residue. | source code

SparseChainSequence

map(self, sparse, reference) Map `sparse`'s residues to `reference`. | source code

Inherited from `object`: `__delattr__`, `__format__`, `__getattribute__`, `__hash__`, `__init__`, `__new__`, `__reduce__`, `__reduce_ex__`, `__repr__`, `__setattr__`, `__sizeof__`, `__str__`, `__subclasshook__`

Class Variables
| __abstractmethods__ = ``frozenset([``'``map``'``])``

Properties
Inherited from `object`: `__class__`

Method Details

### create_gap(self, alphabet=<ProteinAlphabet: ILE=I, GLN=Q, ...>)

source code

Create and return a new gap residue.

Parameters:
  - `alphabet` (enum) - sequence alphabet; a member of SequenceAlphabets which has GAP item
Returns: ResidueInfo

### map(self, sparse, reference)

source code

Map `sparse`'s residues to `reference`. Return all `sparse` residues, aligned over `reference`, with artificial gap residues inserted at relevant positions. The resulting sequence of sparse residues will always have the same length as the `reference` sequence.

Parameters:
  - `sparse` (SparseChainSequence) - sparse sequence (e.g. derived from ATOMS records)
  - `reference` (SparseChainSequence) - reference, complete sequence (e.g. derived from SEQRES records)
Returns: SparseChainSequence
  all `sparse` residues, optimally aligned over `reference` (with gaps)
Raises:
  - `ResidueMappingError` - if the specified sequences are not alignable

Note: `sparse`'s ranks won't be touched because the `rank` property of the underlying ResidueInfo implementation is not necessarily r/w.